/*---------------------------------------------------------*/
/* REXX program to perform sockets interface calls         */
/*---------------------------------------------------------*/

mproto = "SOCK_STREAM"
mdomain = "AF_INET"
mport   = 2300
maddr   = "INADDR_ANY"


/* init stuff */

PARSE ARG xaddr xport rafCmd

IF (xport <> "") THEN
   mport = xport

rc = RxFuncAdd("SockLoadFuncs", "rxSock", "SockLoadFuncs")
rc = SockLoadFuncs()

serv2.!family = mdomain
serv2.!port   = mport
serv2.!addr   = xaddr

/* create a socket    */

s1 = SockSocket(mdomain, mproto, 0)

SAY SockGetHostId()

SAY "create socket returned "s1
IF (s1 < 0) THEN
  DO
     SockPSock_Errno("SockSocket()")
     rc = SockClose(s1)
     RETURN
  END


/* establish connection to server   */

  rc = SockConnect(s1, "serv2.!")
  SAY "connect returned "rc

  IF (rc < 0) THEN
    DO
       SockPSock_Errno("SockConnect()")
       rc = SockClose(s1)
       RETURN
    END

/* process requests                 */

  Call xprocess


/* close socket       */

  rc = SockClose(s1)

/* terminate and exit */

Return

/*-----------------------------------------------*/
/* procedure to handle receive mode              */
/*-----------------------------------------------*/

xProcess:


  rc = SockSend(s1, rafCmd)

  IF (rc < 0) THEN
    RETURN

  IF (rafCmd == "serverquit") THEN
    RETURN

  xEOF = 0
  DO WHILE xEOF == 0
    rc = SockRecv(s1, "inMsg", 1024)
    IF (inMsg == "no") THEN
      RETURN
    IF (rc > 0) THEN
      DO
         SAY "rc="rc "data: "inMsg
         rc = SockSend(s1, "more")
      END
    ELSE
      bEOF = 1

  END

  RETURN


