/*-----------------------------------------------*/
/* Rexx program used as CGI                      */
/* Sample raffle entry program written in REXX   */
/*  Uses RAFSRVM service program to perform      */
/*  raffle interactions                          */
/*-----------------------------------------------*/
/* NOTE: this would work better if it used the   */
/*       ICS REXX interfaces (cgiutils and       */
/*       cgiparse) but they dont work in a       */
/*       threadsafe fashion                      */
/*-----------------------------------------------*/
/* Table version                                 */
/*-----------------------------------------------*/

env = "OS2ENVIRONMENT"
svrq = "rafqm"
mySleep = 1
goodRc = "0"

SAY "HTTP/1.0 200 OK"
SAY "Content-type: text/html"
SAY ""

SAY "<HTML>"
SAY "<HEAD><TITLE>SCOUG Raffle</TITLE></HEAD>"
SAY "<BODY>"
SAY "<center><H2>SCOUG Raffle Registration</H2></center>"

SAY "<FORM name=scgraf action=/cgi-bin/scgraf2p.cmd method=post>"

Call getForms

rname = getValue("members")
raction = getValue("Action")


/* First register the supplied name */

myq = RXQUEUE("Create")                /*  get a queue to use   */
oldq  = RXQUEUE('Set', svrq)           /*  use the new queue    */

IF (raction == "Register") THEN
 IF (rname > " ") THEN
   DO
     qElement = srvQueue("register " || rname)    /* get primary response  */
     PARSE VAR qElement qRc ":" qCount qMsg
     SAY "<br>"qMsg

     DO WHILE QUEUED() > 0
       pull qElement
       SAY  "<br>" qElement
     END
   END

/* Now get registered members refreshed */

regMem.0 = 0
ix = 0

qElement = srvQueue("getregistered")

PARSE VAR qElement qRc ":" rname

DO WHILE QUEUED() > 0
   parse pull rname
   ix = ix + 1
   regMem.0 = ix
   regMem.ix = rname
END

/* Now get all members refreshed */

allMem.0 = 0
ix = 0

qElement = srvQueue("getall")

PARSE VAR qElement qRc ":" rname

DO WHILE QUEUED() > 0
   parse pull rname
   ix = ix + 1
   allMem.0 = ix
   allMem.ix = rname
END

/* Now perform formatting, cleanup and exit         */

call RXQUEUE "Delete", myq
call RXQUEUE "Set", oldq

SAY "<TABLE border=0>"
SAY "<TR><TH>Available Members</TH><TH>Registered Members</TH></TR>"

SAY "<TD>"
SAY "<select name=members size=16>"
DO ix = 1 TO allMem.0

   nFound = 0
   DO iy = 1 TO regMem.0
      IF (regMem.iy == allMem.ix) THEN
         DO
            nFound = 1
            iy = regMem.0 + 1
         END
   END
   IF (nFound == 0) THEN
      SAY "<option>" allMem.ix
END
SAY "</SELECT>"
SAY "</TD>"

IF (regMem.0 > 0) THEN
  DO 
    SAY "<TD>"
    SAY "<select name=reg size=16>"
    DO ix = 1 TO regMem.0
      SAY "<option>" regMem.ix
    END
    SAY "</select>"
    SAY "</TD>"
  END

SAY "</TR></TABLE>"

SAY "<BR><input type=submit name=Action value=Register> Register selected <b>member</b>"
SAY "<BR><input type=submit name=Action value=Refresh> Refresh member, registered lists"

SAY "</FORM>"
SAY "</BODY></HTML>"

Return

/*----------------------------------------------*/
/* procedure to create forms list               */
/*----------------------------------------------*/

getForms:

   formName.0=0
   formValue.0=0
   ix = 0

   cl = VALUE("Content_Length",,env)   /* test if input values      */

   IF (cl > 0) THEN
     PARSE PULL qs
   ELSE
     qs = VALUE("Query_String",,env)    

   IF (qs == "") THEN
      RETURN

   DO WHILE qs <> ""
      PARSE VAR qs kname "=" kval "&" qs
      ix = ix+1
      formName.0 = ix
      formName.ix = kname
      formValue.0 = ix
      formValue.ix = TRANSLATE(kval, " ", "+")
   END

   Return

/*----------------------------------------------*/
/* procedure to search for a form variable      */
/*  and return its value                        */
/*----------------------------------------------*/

getValue:

  PARSE ARG sname

  DO ix = 1 TO formName.0
    IF formName.ix == sname THEN
      return formValue.ix
  END

  return ""

/*----------------------------------------------*/
/* procedure to perform first level             */
/* queue call                                   */
/*----------------------------------------------*/

srvQueue:

  PARSE ARG smsg                 /* get messageto send */

  call RXQUEUE "Set",  svrq
  PUSH time() " " myq " "smsg    /* queue request */
  call RXQUEUE "Set", myq

  DO WHILE QUEUED() == 0
     Call SysSleep mySleep
  END

  PARSE PULL qlocal

  RETURN qlocal
