/*-----------------------------------------------*/
/* Rexx program used as CGI                      */
/* Sample raffle prize program written in REXX   */
/*  Uses RAFSRVM service program to perform      */
/*  raffle interactions                          */
/*-----------------------------------------------*/
/* NOTE: this would work better if it used the   */
/*       ICS REXX interfaces (cgiutils and       */
/*       cgiparse) but they dont work in a       */
/*       threadsafe fashion                      */
/*-----------------------------------------------*/
/* Table version                                 */
/*-----------------------------------------------*/

env = "OS2ENVIRONMENT"
svrq = "rafqm"
mySleep = 1
goodRc = "0"

SAY "HTTP/1.0 200 OK"
SAY "Content-type: text/html"
SAY ""

SAY "<HTML>"
SAY "<HEAD><TITLE>SCOUG Raffle Drawing</TITLE></HEAD>"
SAY "<BODY>"
SAY "<center><H2>SCOUG Raffle Drawing</H2></center>"

SAY "<FORM name=scgraf action=/cgi-bin/scgraf2w.cmd method=post>"

Call getForms

raction = getValue("Action")
rmode   = getValue("Mode")

/* First issue SETDRAW if necessary */

myq = RXQUEUE("Create")                /*  get a queue to use   */
oldq  = RXQUEUE('Set', svrq)           /*  use the new queue    */

IF (raction == "PickWinner") THEN
   DO
     qElement = srvQueue("pickwinner")        /* get primary response  */
     PARSE VAR qElement qRc ":" qWinner
     SAY "<br><b><center><FONT size=16>" qWinner "</FONT></b></center><br>"
   END
ELSE
   DO
      qElement = srvQueue("setdraw")
      PARSE VAR qElement qRc ":" qMsg
      SAY "<br>" qMsg
   END

/* Now get winners refreshed */

winners.0 = 0
ix = 0

qElement = srvQueue("getwinners")

PARSE VAR qElement qRc ":" rname

DO WHILE QUEUED() > 0
   parse pull rname
   ix = ix + 1
   winners.0 = ix
   winners.ix = rname
END

/* Now perform formatting, cleanup and exit         */

call RXQUEUE "Delete", myq
call RXQUEUE "Set", oldq

IF (winners.0 > 0) THEN
  DO
     SAY "<h2>Winners Are: </h2>"
     SAY "<br><ol>"
     DO ix = 1 TO winners.0
        SAY "<li>"winners.ix
     END
     SAY "</ol>"
  END

SAY "<BR><input type=submit name=Action value=PickWinner> Pick (next) Winner"
SAY '<BR><input type=hidden name=prev value="'qWinner'">'

SAY "</FORM>"
SAY "</BODY></HTML>"

Return

/*----------------------------------------------*/
/* procedure to create forms list               */
/*----------------------------------------------*/

getForms:

   formName.0=0
   formValue.0=0
   ix = 0

   cl = VALUE("Content_Length",,env)   /* test if input values      */

   IF (cl > 0) THEN
     PARSE PULL qs
   ELSE
     qs = VALUE("Query_String",,env)    

   IF (qs == "") THEN
      RETURN

   DO WHILE qs <> ""
      PARSE VAR qs kname "=" kval "&" qs
      ix = ix+1
      formName.0 = ix
      formName.ix = kname
      formValue.0 = ix
      formValue.ix = TRANSLATE(kval, " ", "+")
   END

   Return

/*----------------------------------------------*/
/* procedure to search for a form variable      */
/*  and return its value                        */
/*----------------------------------------------*/

getValue:

  PARSE ARG sname

  DO ix = 1 TO formName.0
    IF formName.ix == sname THEN
      return formValue.ix
  END

  return ""

/*----------------------------------------------*/
/* procedure to perform first level             */
/* queue call                                   */
/*----------------------------------------------*/

srvQueue:

  PARSE ARG smsg                 /* get messageto send */

  call RXQUEUE "Set",  svrq
  PUSH time() myq smsg           /* queue request */
  call RXQUEUE "Set", myq

  DO WHILE QUEUED() == 0
     Call SysSleep mySleep
  END

  PARSE PULL qlocal

  RETURN qlocal
